; Weak references
;; The scheme implementation provides no weak references,
;; so we simulate the weak reference interface with it;


(require 'types)
(provide 'weak-ref)


(define weak-ref$$mark (cons 'weak-ref weak-ref$$mark))

(define (weak-ref obj fin)
   "make a weak reference to object obj,
with finalizer thread fin to be activated whenever the reference breaks"
   (list weak-ref$$mark #t obj fin))

(define (weak-ref? o)
   (and (pair? o) (eq? (car o) weak-ref$$mark)))

(define (weak-ref:get w cf cn)
   ($assert weak-ref? w)
   ; make it atomic wrt GC
   (let* ((obj   (caddr w))
          (flag (cadr w)))
   (if flag (cf obj) (cn))))

(define (weak-ref:break w)
   ($assert weak-ref? w)
   (set-car! #f (cdr w))
   (set-car! #f (cddr w))
   (activate-thread (cadddr w)))

;(register-type 'weak-ref weak-ref?)
